/*
  binforge - Repository system for Windows
  Copyright (C) 2009 Younes Serraj  Tous droits rservs.

  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la GNU General Public License telle que
  publie par la Free Software Foundation : soit la version 3 de cette
  licence, soit ( votre gr) toute version ultrieure.

  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS
  AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT
  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale
  Publique GNU pour plus de dtails.

  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec
  ce programme ; si ce nest pas le cas, consultez :
  <http://www.gnu.org/licenses/>.
*/

#ifdef BINFORGE_H
#ifndef PACKAGES_REPOSITORY_C
#define PACKAGES_REPOSITORY_C

int pkgr_init() {
	if ((int*)opendir(BINFORGE_PACKAGES_REPOSITORY) == NULL) {
		if (mkdir(BINFORGE_PACKAGES_REPOSITORY) == 0)
			return true;
		else
			return false;
	}
	else
		return true;
}

char *pkgr_get_filepath(int pkg_id) {
	char *filepath;

	filepath = (char*)malloc(sizeof(char)*strlen(BINFORGE_PACKAGES_REPOSITORY) + 20);

	if (filepath == NULL)
		return false;

	sprintf(filepath, "%s\\%d\0", BINFORGE_PACKAGES_REPOSITORY, pkg_id);

	return (char*)filepath;
}

int pkgr_add(int pkg_id, char *srcpath) {
	char *destpath;
	
	if (file_exists(srcpath) == false)
		return false;
		
	destpath = pkgr_get_filepath(pkg_id);
	
	if (destpath == NULL)
		return false;
		
	return copy_file(srcpath, destpath);
}

int pkgr_delete(int pkg_id) {
	char *filepath;

	filepath = pkgr_get_filepath(pkg_id);

	if (filepath == NULL)
		return false;

	if (remove(filepath) == 0)
		return true;
	else
		return false;
}

int pkgr_exists(int pkg_id) {
	char *filepath;

	filepath = pkgr_get_filepath(pkg_id);

	if (filepath == NULL)
		return false;

	return file_exists(filepath);
}

FILE *pkgr_get(int pkg_id) {
	char *filepath;

	filepath = pkgr_get_filepath(pkg_id);

	if (filepath == NULL)
		return false;
	
	return (FILE*)fopen(filepath, "rb");
}

#endif PACKAGES_REPOSITORY_C
#endif BINFORGE_H
